#include "cheader.h"

// initialize the cabinet header
// set sign (must be set to 'MSCF')
//     number of folders
//     number of files
//     flags (multiple folder/set)
//     set ID
//     cabinet ID
void cheader_init(struct cheader *ch, char *sign, 
		    int nfolders, int nfiles, 
		    int flags, int setID, 
		    int cabID)
{
	int i;

	for(i=0;i<4;++i) { ch->sig[i] = *(sign+i); }
	ch->res1 = 0;
	ch->res2 = 0;
	ch->res3 = 0;
	ch->versionMAJ = 1;
	ch->versionMIN = 3;
	ch->nfolders = nfolders;
	ch->nfiles = nfiles;
	ch->flags = flags;
	ch->setID = setID;
	ch->cabID = cabID;
}

// set total cabinet file size
void cheader_size(struct cheader *ch, int size) 
{ 
	ch->size = size; 
}

// offset where cabfile-entries start
void cheader_offsetfiles(struct cheader *ch, int offset) 
{ 	
	ch->offsetfiles = offset; 
}

