#include "checksum.h"

// compute the checksum for the datablock
CHECKSUM compute_checksum(byte *in, word ncbytes, CHECKSUM seed)
{
	int no_ulongs;
	CHECKSUM csum=0;
	byte *stroom;
	CHECKSUM temp;

	no_ulongs = ncbytes / 4;
	csum = seed;
	stroom = in;

	while(no_ulongs-->0)
	{
		temp = ((CHECKSUM) (*stroom++));
		temp |= (((CHECKSUM) (*stroom++)) << 8);
		temp |= (((CHECKSUM) (*stroom++)) << 16);
		temp |= (((CHECKSUM) (*stroom++)) << 24);

		csum ^= temp;
	}

	temp = 0;
	switch(ncbytes%4)
	{
		case 3: temp |= (((CHECKSUM) (*stroom++)) << 16);
		case 2: temp |= (((CHECKSUM) (*stroom++)) << 8);
		case 1: temp |= ((CHECKSUM) (*stroom++));
		default: break;
	}
	
	csum ^= temp;

	return csum;	
}
